<template>
	<div>
		<div class="cards">
			<h4>Eingetragene Events</h4>
			<div class="card-body">
				<div class="cols c-0-1-0-0 b-gap-1">
					<div class="cell c-merged-2">
						<custom-switch @clicked="globalToggleDeleteButtons" />
						L&ouml;schen
					</div>
					<div class="cell">K</div>
					<div class="cell">B</div>
					<template v-for="event in eventsPaginated">
						<div :key="'col1-' + event.id" class="cell button-row--icons">
							<button ref="delete" @click="deleteEvent(event.id)" class="button button--close" disabled></button>
							<router-link :to="'/admin/events/edit/' + event.id" ref="edit" class="button button--edit"></router-link>
						</div>
						<div :key="'col2-' + event.id" class="cell bg-4">{{ event.title }}</div>
						<div :key="'col3-' + event.id" class="cell text-center" :class="[ event.totalCommentsOnEvent ? 'bg-4' : 'bg-t1' ]">{{ event.totalCommentsOnEvent }}</div>
						<div :key="'col4-' + event.id" class="cell text-center" :class="[ event.totalUsersAttendingEvent ? 'bg-4' : 'bg-t1' ]">{{ event.totalUsersAttendingEvent }}</div>
					</template>
				</div>

				<paginator @clicked="fetchEventsPaginated" :limiter="2" :total-pages="totalPages" :current-page="currentPage" />

			</div>

			<div class="cell">
				K: Kommentare, B: Besucher
			</div>
		</div>

		<loader v-if="isLoading" />

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>
</template>

<script>
import CustomSwitch from "@/components/buttons/CustomSwitch";
import SystemMessage from "@/components/SystemMessage";
import Loader from "@/components/Loader";
import Paginator from "@/components/Paginator";

export default {
	name: "AdminEvents",
	components: {
		Paginator,
		Loader,
		CustomSwitch,
		SystemMessage
	},
	data: () => ({
		isLoading: false,
		eventsPaginated: {},
		totalPages: 0,
		currentPage: 1,
		sysMsg: undefined
	}),
	methods: {
		async fetchEventsPaginated(page = 1) {
			this.isLoading = true;
			const response = await this.$http.get("/api/events/page/" + page);
			this.currentPage = page;
			this.totalPages = response.data.totalPages;
			this.eventsPaginated = response.data.paginatedContent;
			this.isLoading = false;
		},

		async deleteEvent(id) {
			this.sysMsg = "";
			try {
				const response = await this.$http.delete("/api/admin/events/delete/" + id);
				switch (response.status) {
					case 200:
						this.sysMsg = "Event erfolgreich gelöscht!";
						await this.fetchEventsPaginated();
						break;
				}
			} catch (e) {
				console.error(e);
			}
		}
	},
	computed: {
/*
		allEvents() {
			return this.$store.getters.getAllEvents;
		}
*/
	},
	mounted() {
/*
		this.isLoading = true;
		this.$store.dispatch("getAllEvents").then(() => this.isLoading = false);
*/
		this.fetchEventsPaginated();
	}
}
</script>

<style scoped>

</style>